/*
 * Hantro Decoder device driver (kernel module)
*
* Copyright (C) 2020  VeriSilicon Microelectronics Co., Ltd.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*
------------------------------------------------------------------------------*/

#ifdef __FREERTOS__
#include "basetype.h"
#include "dev_common_freertos.h"
#include "io_tools.h"
#elif defined(__linux__)
#include <linux/version.h>
#include <linux/slab.h>
#include <linux/vmalloc.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/debugfs.h>
#include <linux/types.h>
#include <linux/device.h>
#include <linux/pagemap.h>
#include <linux/sched.h>
#include <stddef.h>
#include <linux/platform_device.h>
#include <linux/dma-buf.h>
#endif

#include "hantroaxife.h"

#define HANTRO_AXIFE_OFFSET 0

void AXIFEEnable(volatile unsigned char *hwregs)
{
	if (!hwregs)
		return;

	//AXI FE pass through
	iowrite32(0x0, (void *)(hwregs + HANTRO_AXIFE_OFFSET + 0x2C));
	printk(KERN_INFO "AXI FE: 0x2C = 0x%x\n",
	       ioread32((void *)(hwregs + 0x2C)));
	iowrite32(0x2, (void *)(hwregs + HANTRO_AXIFE_OFFSET + 0x28));
	printk(KERN_INFO "AXI FE: 0x28 = 0x%x\n",
	       ioread32((void *)(hwregs + 0x28)));
}
